variables:
  IMAGE_NAME: $CI_PROJECT_PATH_SLUG.$CI_COMMIT_BRANCH
#   PROVIDER: aws
  IMAGE_TAG: $CI_PIPELINE_ID
#   NAMESPACE: $CI_PROJECT_PATH_SLUG.$CI_COMMIT_BRANCH
  REPLICAS: 1
#   APP: $CI_PROJECT_PATH_SLUG
#   PORT: 80
#   SECRET_NAME: my-secret
#   FORWARD_PORT: 8080

stages:
  - build_image
  - push_image
  - deploy_ifra

build_image:
  image: docker:20.10.16
  # services:
  #   - docker:20.10.16-dind
  stage: build_image
  before_script:
    - docker login -u $DOCKER_USER -p $DOCKER_PASS
  script:
    - docker build -t $DOCKER_USER/$IMAGE_NAME:$IMAGE_TAG .
    - docker images
    - docker ps


push_image:
  image: docker:20.10.16
  # services:
  #   - docker:20.10.16-dind
  stage: push_image
  before_script:
    - docker login -u $DOCKER_USER -p $DOCKER_PASS
  script:
    - docker image ls
    - docker push $DOCKER_USER/$IMAGE_NAME:$IMAGE_TAG

deploy_ifra:
  image: ubuntu:latest
  stage: deploy_ifra
  before_script:
    - apt update
    - apt install git -y
    - git config --global user.email "fluxCD@luulongtien"
    - git config --global user.name "luulongtien"
  script:
    - git clone https://ACCESS_TOKEN@gitlab.com/longtien.5601/cd-k8s.git
    - cd cd-k8s
    - pwd
    - cd dev
    - sh change-image.sh
    - git add .
    - git commit -m "infra updated"
    - git push https://cd-token-access:$ACCESS_TOKEN@gitlab.com/longtien.5601/cd-k8s.git